<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.math.array;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import ch.javasoft.math.linalg.GaussPivotingFactory;<a name="line.36"></a>
<FONT color="green">037</FONT>    import ch.javasoft.math.linalg.LinAlgOperations;<a name="line.37"></a>
<FONT color="green">038</FONT>    import ch.javasoft.math.operator.AggregatingBinaryOperator;<a name="line.38"></a>
<FONT color="green">039</FONT>    import ch.javasoft.math.operator.AggregatingUnaryOperator;<a name="line.39"></a>
<FONT color="green">040</FONT>    import ch.javasoft.math.operator.BinaryOperator;<a name="line.40"></a>
<FONT color="green">041</FONT>    import ch.javasoft.math.operator.BooleanBinaryOperator;<a name="line.41"></a>
<FONT color="green">042</FONT>    import ch.javasoft.math.operator.BooleanUnaryOperator;<a name="line.42"></a>
<FONT color="green">043</FONT>    import ch.javasoft.math.operator.ConvertingUnaryOperator;<a name="line.43"></a>
<FONT color="green">044</FONT>    import ch.javasoft.math.operator.DivisionSupport;<a name="line.44"></a>
<FONT color="green">045</FONT>    import ch.javasoft.math.operator.IntBinaryOperator;<a name="line.45"></a>
<FONT color="green">046</FONT>    import ch.javasoft.math.operator.IntUnaryOperator;<a name="line.46"></a>
<FONT color="green">047</FONT>    import ch.javasoft.math.operator.NullaryOperator;<a name="line.47"></a>
<FONT color="green">048</FONT>    import ch.javasoft.math.operator.UnaryOperator;<a name="line.48"></a>
<FONT color="green">049</FONT>    <a name="line.49"></a>
<FONT color="green">050</FONT>    <a name="line.50"></a>
<FONT color="green">051</FONT>    /**<a name="line.51"></a>
<FONT color="green">052</FONT>     * The &lt;code&gt;NumberOperators&lt;/code&gt; defines standard operators for different<a name="line.52"></a>
<FONT color="green">053</FONT>     * number types. An instance of this class defines the (boxed) number type and <a name="line.53"></a>
<FONT color="green">054</FONT>     * the array type, such as {@link Double} and {@code double[]}. <a name="line.54"></a>
<FONT color="green">055</FONT>     * <a name="line.55"></a>
<FONT color="green">056</FONT>     * @type T      number type<a name="line.56"></a>
<FONT color="green">057</FONT>     * @type A      array type of number<a name="line.57"></a>
<FONT color="green">058</FONT>     */<a name="line.58"></a>
<FONT color="green">059</FONT>    public interface NumberOperators&lt;N extends Number, A&gt; {<a name="line.59"></a>
<FONT color="green">060</FONT>            /**<a name="line.60"></a>
<FONT color="green">061</FONT>             * Returns the number type class for a single value<a name="line.61"></a>
<FONT color="green">062</FONT>             */<a name="line.62"></a>
<FONT color="green">063</FONT>            Class&lt;N&gt; numberClass();<a name="line.63"></a>
<FONT color="green">064</FONT>    <a name="line.64"></a>
<FONT color="green">065</FONT>            /**<a name="line.65"></a>
<FONT color="green">066</FONT>             * Returns the number type class of an array of values<a name="line.66"></a>
<FONT color="green">067</FONT>             */<a name="line.67"></a>
<FONT color="green">068</FONT>            Class&lt;A&gt; arrayClass();<a name="line.68"></a>
<FONT color="green">069</FONT>            <a name="line.69"></a>
<FONT color="green">070</FONT>            /**<a name="line.70"></a>
<FONT color="green">071</FONT>             * Returns the kind of {@link DivisionSupport} for this operators instance<a name="line.71"></a>
<FONT color="green">072</FONT>             */<a name="line.72"></a>
<FONT color="green">073</FONT>            DivisionSupport getDivisionSupport();<a name="line.73"></a>
<FONT color="green">074</FONT>            <a name="line.74"></a>
<FONT color="green">075</FONT>            /**<a name="line.75"></a>
<FONT color="green">076</FONT>             * Returns the array operations instance based on {@code this} operators <a name="line.76"></a>
<FONT color="green">077</FONT>             * instance<a name="line.77"></a>
<FONT color="green">078</FONT>             */<a name="line.78"></a>
<FONT color="green">079</FONT>            ArrayOperations&lt;A&gt; getArrayOperations();<a name="line.79"></a>
<FONT color="green">080</FONT>            /**<a name="line.80"></a>
<FONT color="green">081</FONT>             * Returns the number array operations instance based on {@code this} <a name="line.81"></a>
<FONT color="green">082</FONT>             * operators instance<a name="line.82"></a>
<FONT color="green">083</FONT>             */<a name="line.83"></a>
<FONT color="green">084</FONT>            NumberArrayOperations&lt;N, A&gt; getNumberArrayOperations();<a name="line.84"></a>
<FONT color="green">085</FONT>            /**<a name="line.85"></a>
<FONT color="green">086</FONT>             * Returns the linear algebra operations instance based on {@code this}<a name="line.86"></a>
<FONT color="green">087</FONT>             * operators instance<a name="line.87"></a>
<FONT color="green">088</FONT>             */<a name="line.88"></a>
<FONT color="green">089</FONT>            LinAlgOperations&lt;N, A&gt; getLinAlgOperations();<a name="line.89"></a>
<FONT color="green">090</FONT>            /**<a name="line.90"></a>
<FONT color="green">091</FONT>             * Returns the linear algebra operations instance based on {@code this}<a name="line.91"></a>
<FONT color="green">092</FONT>             * operators instance with Gauss pivoting created the given factory  <a name="line.92"></a>
<FONT color="green">093</FONT>             */<a name="line.93"></a>
<FONT color="green">094</FONT>            LinAlgOperations&lt;N, A&gt; getLinAlgOperations(GaussPivotingFactory&lt;N, A&gt; gaussPivotingFactory);<a name="line.94"></a>
<FONT color="green">095</FONT>            <a name="line.95"></a>
<FONT color="green">096</FONT>    <a name="line.96"></a>
<FONT color="green">097</FONT>            /**<a name="line.97"></a>
<FONT color="green">098</FONT>             * Returns the number value representing zero<a name="line.98"></a>
<FONT color="green">099</FONT>             */<a name="line.99"></a>
<FONT color="green">100</FONT>            N zero();<a name="line.100"></a>
<FONT color="green">101</FONT>    <a name="line.101"></a>
<FONT color="green">102</FONT>            /**<a name="line.102"></a>
<FONT color="green">103</FONT>             * Returns the number value representing one<a name="line.103"></a>
<FONT color="green">104</FONT>             */<a name="line.104"></a>
<FONT color="green">105</FONT>            N one();<a name="line.105"></a>
<FONT color="green">106</FONT>            <a name="line.106"></a>
<FONT color="green">107</FONT>            /**<a name="line.107"></a>
<FONT color="green">108</FONT>             * Returns a const operator for the specified constant {@code value}, <a name="line.108"></a>
<FONT color="green">109</FONT>             * matching number and array type defined by this {@code NumberOperators} <a name="line.109"></a>
<FONT color="green">110</FONT>             * instance.<a name="line.110"></a>
<FONT color="green">111</FONT>             * <a name="line.111"></a>
<FONT color="green">112</FONT>             * @param value the constant value returned by the constant operator<a name="line.112"></a>
<FONT color="green">113</FONT>             * @return      the operator implementation for the current number/array type<a name="line.113"></a>
<FONT color="green">114</FONT>             */<a name="line.114"></a>
<FONT color="green">115</FONT>            NullaryOperator&lt;N, A&gt; constant(N value);<a name="line.115"></a>
<FONT color="green">116</FONT>    <a name="line.116"></a>
<FONT color="green">117</FONT>            /**<a name="line.117"></a>
<FONT color="green">118</FONT>             * Returns a converting unary operator which is able to convert any<a name="line.118"></a>
<FONT color="green">119</FONT>             * {@link Number} instance to a specific number instance.<a name="line.119"></a>
<FONT color="green">120</FONT>             * <a name="line.120"></a>
<FONT color="green">121</FONT>             * @return      the unary converter<a name="line.121"></a>
<FONT color="green">122</FONT>             */<a name="line.122"></a>
<FONT color="green">123</FONT>            ConvertingUnaryOperator&lt;Number, Number[], N, A&gt; converter();<a name="line.123"></a>
<FONT color="green">124</FONT>            <a name="line.124"></a>
<FONT color="green">125</FONT>            /**<a name="line.125"></a>
<FONT color="green">126</FONT>             * Returns the nullary operator identified by operator id, matching<a name="line.126"></a>
<FONT color="green">127</FONT>             * number and array type defined by this {@code NumberOperators} instance.<a name="line.127"></a>
<FONT color="green">128</FONT>             * <a name="line.128"></a>
<FONT color="green">129</FONT>             * @param id    the identifier for the desired operator<a name="line.129"></a>
<FONT color="green">130</FONT>             * @return      the operator implementation for the current number/array type<a name="line.130"></a>
<FONT color="green">131</FONT>             */<a name="line.131"></a>
<FONT color="green">132</FONT>            NullaryOperator&lt;N, A&gt; nullary(NullaryOperator.Id id);<a name="line.132"></a>
<FONT color="green">133</FONT>    <a name="line.133"></a>
<FONT color="green">134</FONT>            /**<a name="line.134"></a>
<FONT color="green">135</FONT>             * Returns the unary operator identified by operator id, matching<a name="line.135"></a>
<FONT color="green">136</FONT>             * number and array type defined by this {@code NumberOperators} instance.<a name="line.136"></a>
<FONT color="green">137</FONT>             * <a name="line.137"></a>
<FONT color="green">138</FONT>             * @param id    the identifier for the desired operator<a name="line.138"></a>
<FONT color="green">139</FONT>             * @return      the operator implementation for the current number/array type<a name="line.139"></a>
<FONT color="green">140</FONT>             */<a name="line.140"></a>
<FONT color="green">141</FONT>            UnaryOperator&lt;N, A&gt; unary(UnaryOperator.Id id);<a name="line.141"></a>
<FONT color="green">142</FONT>            /**<a name="line.142"></a>
<FONT color="green">143</FONT>             * Returns the int-unary operator identified by operator id, matching<a name="line.143"></a>
<FONT color="green">144</FONT>             * number and array type defined by this {@code NumberOperators} instance.<a name="line.144"></a>
<FONT color="green">145</FONT>             *  <a name="line.145"></a>
<FONT color="green">146</FONT>             * @param id    the identifier for the desired operator<a name="line.146"></a>
<FONT color="green">147</FONT>             * @return      the operator implementation for the current number/array type<a name="line.147"></a>
<FONT color="green">148</FONT>             */<a name="line.148"></a>
<FONT color="green">149</FONT>            IntUnaryOperator&lt;N, A&gt; intUnary(IntUnaryOperator.Id id);<a name="line.149"></a>
<FONT color="green">150</FONT>            /**<a name="line.150"></a>
<FONT color="green">151</FONT>             * Returns the boolean-unary operator identified by operator id, matching<a name="line.151"></a>
<FONT color="green">152</FONT>             * number and array type defined by this {@code NumberOperators} instance.<a name="line.152"></a>
<FONT color="green">153</FONT>             * <a name="line.153"></a>
<FONT color="green">154</FONT>             * @param id    the identifier for the desired operator<a name="line.154"></a>
<FONT color="green">155</FONT>             * @return      the operator implementation for the current number/array type<a name="line.155"></a>
<FONT color="green">156</FONT>             */<a name="line.156"></a>
<FONT color="green">157</FONT>            BooleanUnaryOperator&lt;N, A&gt; booleanUnary(BooleanUnaryOperator.Id id);<a name="line.157"></a>
<FONT color="green">158</FONT>            <a name="line.158"></a>
<FONT color="green">159</FONT>            /**<a name="line.159"></a>
<FONT color="green">160</FONT>             * Returns the binary operator identified by operator id, matching<a name="line.160"></a>
<FONT color="green">161</FONT>             * number and array type defined by this {@code NumberOperators} instance.<a name="line.161"></a>
<FONT color="green">162</FONT>             * <a name="line.162"></a>
<FONT color="green">163</FONT>             * @param id    the identifier for the desired operator<a name="line.163"></a>
<FONT color="green">164</FONT>             * @return      the operator implementation for the current number/array type<a name="line.164"></a>
<FONT color="green">165</FONT>             */<a name="line.165"></a>
<FONT color="green">166</FONT>            BinaryOperator&lt;N, A&gt; binary(BinaryOperator.Id id);<a name="line.166"></a>
<FONT color="green">167</FONT>            /**<a name="line.167"></a>
<FONT color="green">168</FONT>             * Returns the int-binary operator identified by operator id, matching<a name="line.168"></a>
<FONT color="green">169</FONT>             * number and array type defined by this {@code NumberOperators} instance.<a name="line.169"></a>
<FONT color="green">170</FONT>             * <a name="line.170"></a>
<FONT color="green">171</FONT>             * @param id    the identifier for the desired operator<a name="line.171"></a>
<FONT color="green">172</FONT>             * @return      the operator implementation for the current number/array type<a name="line.172"></a>
<FONT color="green">173</FONT>             */<a name="line.173"></a>
<FONT color="green">174</FONT>            IntBinaryOperator&lt;N, A&gt; intBinary(IntBinaryOperator.Id id);<a name="line.174"></a>
<FONT color="green">175</FONT>            /**<a name="line.175"></a>
<FONT color="green">176</FONT>             * Returns the boolean-binary operator identified by operator id, matching<a name="line.176"></a>
<FONT color="green">177</FONT>             * number and array type defined by this {@code NumberOperators} instance.<a name="line.177"></a>
<FONT color="green">178</FONT>             * <a name="line.178"></a>
<FONT color="green">179</FONT>             * @param id    the identifier for the desired operator<a name="line.179"></a>
<FONT color="green">180</FONT>             * @return      the operator implementation for the current number/array type<a name="line.180"></a>
<FONT color="green">181</FONT>             */<a name="line.181"></a>
<FONT color="green">182</FONT>            BooleanBinaryOperator&lt;N, A&gt; booleanBinary(BooleanBinaryOperator.Id id);<a name="line.182"></a>
<FONT color="green">183</FONT>            /**<a name="line.183"></a>
<FONT color="green">184</FONT>             * Returns the aggregating unary operator identified by operator id, <a name="line.184"></a>
<FONT color="green">185</FONT>             * matching number and array type defined by this {@code NumberOperators} <a name="line.185"></a>
<FONT color="green">186</FONT>             * instance.<a name="line.186"></a>
<FONT color="green">187</FONT>             * <a name="line.187"></a>
<FONT color="green">188</FONT>             * @param id    the identifier for the desired operator<a name="line.188"></a>
<FONT color="green">189</FONT>             * @return      the operator implementation for the current number/array type<a name="line.189"></a>
<FONT color="green">190</FONT>             */<a name="line.190"></a>
<FONT color="green">191</FONT>            AggregatingUnaryOperator&lt;N, A&gt; aggregatingUnary(AggregatingUnaryOperator.Id id);<a name="line.191"></a>
<FONT color="green">192</FONT>            /**<a name="line.192"></a>
<FONT color="green">193</FONT>             * Returns the aggregating binary operator identified by operator id, <a name="line.193"></a>
<FONT color="green">194</FONT>             * matching number and array type defined by this {@code NumberOperators} <a name="line.194"></a>
<FONT color="green">195</FONT>             * instance.<a name="line.195"></a>
<FONT color="green">196</FONT>             * <a name="line.196"></a>
<FONT color="green">197</FONT>             * @param id    the identifier for the desired operator<a name="line.197"></a>
<FONT color="green">198</FONT>             * @return      the operator implementation for the current number/array type<a name="line.198"></a>
<FONT color="green">199</FONT>             */<a name="line.199"></a>
<FONT color="green">200</FONT>            AggregatingBinaryOperator&lt;N, A&gt; aggregatingBinary(AggregatingBinaryOperator.Id id);<a name="line.200"></a>
<FONT color="green">201</FONT>    <a name="line.201"></a>
<FONT color="green">202</FONT>    }<a name="line.202"></a>




























































</PRE>
</BODY>
</HTML>
